'#################################################################################################
'#
'#   Yahoo Socket Class
'#
'#   Purpose: To communicate over Yahoo Chat service.
'#
'#   Written by Xeon Productions
'#   Copyright 2004 Xeon Productions
'#   Contact: Brandon Scott [xeons@xeons.net]
'#   Website: http://www.xeons.net/
'# 
'#   If you use this code please ask permission first, or give
'#   credit where credit is due.
'#
'#   Comments: .NET was far too slow to generate a response quick enough, forcing me to use
'#   a DLL to get the response strings. THANK YOU GAIM FOR THE CODE!
'#
'#################################################################################################

Imports System.Runtime.InteropServices

Public Class YahooChallengeResponse
    Private Declare Function GetLoginStrings Lib "YMSG12Encryption.dll" (ByVal username As String, ByVal password As String, ByVal seed As String, ByVal result1 As String, ByVal result2 As String) As Boolean

    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=96)> Private ChallengeResult1 As String
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=96)> Private ChallengeResult2 As String

    Private m_Username As String
    Private m_Password As String
    Private m_Challenge As String

    Public Function GetLoginStrings() As String()
        Dim s(1) As String
        Try
            ChallengeResult1 = StrDup(96, Chr(0))
            ChallengeResult2 = StrDup(96, Chr(0))
            Call GetLoginStrings(m_Username, m_Password, m_Challenge, ChallengeResult1, ChallengeResult2)
            s(0) = ChallengeResult1.Substring(0, ChallengeResult1.IndexOf(Chr(0)))
            s(1) = ChallengeResult2.Substring(0, ChallengeResult2.IndexOf(Chr(0)))
            Return s
        Catch ex As Exception
            Debug.WriteLine("GetLoginStrings: " & ex.Message)
        End Try
    End Function

    Public Property Username() As String
        Get
            Return m_Username
        End Get
        Set(ByVal Value As String)
            m_Username = Value
        End Set
    End Property

    Public Property Password() As String
        Get
            Return m_Password
        End Get
        Set(ByVal Value As String)
            m_Password = Value
        End Set
    End Property

    Public Property Challenge() As String
        Get
            Return m_Challenge
        End Get
        Set(ByVal Value As String)
            m_Challenge = Value
        End Set
    End Property

End Class
